/*
 * NAME:
 *	extern - macros for managing globals
 *
 * AUTHOR:
 *	Simon J. Gerraty <sjg@quick.com.au>
 */
/*
 * RCSid:
 *	$Id: extern.h,v 1.2 1999/03/16 12:29:26 sjg Exp $
 *
 *	@(#)Copyright (c) 1998 QUICK.COM.AU. All rights reserved.
 *	@(#)Copyright (c) 1993 Simon J. Gerraty. All rights reserved.
 *	
 *	This file is provided in the hope that it will
 *	be of use.  There is absolutely NO WARRANTY.
 *	Permission to use, modify and distribute this source code 
 *	is granted subject to the following conditions.
 *	1/ that the above copyright notice and this notice 
 *	are preserved in all copies and that due credit be given 
 *	to the author.	
 *	2/ that any changes to this code are clearly commented 
 *	as such so that the author does not get blamed for bugs 
 *	other than his own.
 *	3/ If there is an accompanying License file its provisions
 *	must also be met.
 *	
 *	Please send copies of changes and bug-fixes to:
 *	sjg@quick.com.au
 */

/*
 *	These may well need to be defined multiple times
 *	If this is required, #undef _EXTERN_H before second #include
 */
#if !defined(_EXTERN_H)
# define _EXTERN_H

#undef EXTERN
#undef INIT
#undef DO_INIT

#ifdef _EXTERN
# define EXTERN
# define INIT(i)	i
# define DO_INIT	1
#else
# define EXTERN		extern
# define INIT(x)
# define DO_INIT	0
#endif

/*
 * struct initialization can be done thus:
 * 
 * struct foo
 * {
 *	int a;
 *	int b;
 * }
 *	Foos[]
 * #if DO_INIT
 * = {
 * 	1, 2,
 * 	3, 4,
 * }
 * #endif
 * ;
 *
 */
#endif	/* _EXTERN_H */
