/* NAME:
 *      get_addr_list - front end gethostby*
 *
 * AUTHOR:
 *      Simon Gerraty <sjg@quick.com.au>
 */
/*
 *      @(#)Copyright (c) 1994, Simon J. Gerraty.
 *      
 *      This is free software.  It comes with NO WARRANTY.
 *      Permission to use, modify and distribute this source code 
 *      is granted subject to the following conditions.
 *      1/ that the above copyright notice and this notice 
 *      are preserved in all copies and that due credit be given 
 *      to the author.  
 *      2/ that any changes to this code are clearly commented 
 *      as such so that the author does not get blamed for bugs 
 *      other than his own.
 *      
 *      Please send copies of changes and bug-fixes to:
 *      sjg@quick.com.au
 */

#ifndef lint
static char RCSid[] = "$Id: getipaddr.c,v 1.5 1998/11/13 02:40:41 sjg Exp $";
#endif
#include <stdio.h>
#ifdef __STDC__
#include <stdlib.h>
#endif
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <fcntl.h>
#include <ctype.h>
#include <errno.h>
#include <sys/cdefs.h>
#ifdef SOCKS
# include "socks.h"
#endif

char **
get_addr_list(host)
	const char *host;
{
	char			**addr_list = NULL;
	static char		*addrs[2];
	static unsigned long	ip_addr = 0;
	struct hostent		*hp;

	if (strspn(host, "0123456789.") == strlen(host)) {
		ip_addr = inet_addr(host);
		if ((hp = gethostbyaddr((char *) &ip_addr,
					sizeof (ip_addr), AF_INET)) != NULL) {
			addr_list = hp->h_addr_list;
		} else {
			addrs[0] = (char *) &ip_addr;
			addrs[1] = NULL;
			addr_list = addrs;
		}
	} else {
		/*
		 *	Not an IP addr, a hostname?
		 */
		if ((hp = gethostbyname(host)) != NULL) {
			addr_list = hp->h_addr_list;
		}
	}
	return addr_list;
}

unsigned long
get_ip_addr(host)
	char *host;
{
	unsigned long		ip_addr = 0;
	char			**addr_list = get_addr_list(host);

	if (addr_list)
		ip_addr = *((unsigned long *) *addr_list);
	return ip_addr;
}
